## sasquatch 0.1.3

=== DESCRIPTION ===
Package: sasquatch
Title: Use 'SAS', R, and 'quarto' Together
Version: 0.1.3
Authors@R: 
    person("Ryan", "Zomorrodi", , "rzomor2@uic.edu", role = c("aut", "cre", "cph"),
           comment = c(ORCID = "0009-0003-6417-5985"))
Description: Use R and 'SAS' within reproducible multilingual 'quarto'
    documents. Run 'SAS' code blocks interactively, send data back and
    forth between 'SAS' and R, and render 'SAS' output within 'quarto'
    documents. 'SAS' connections are established through a combination of
    'SASPy' and 'reticulate'.
License: MIT + file LICENSE
URL: https://docs.ropensci.org/sasquatch/,
        https://github.com/ropensci/sasquatch
BugReports: https://github.com/ropensci/sasquatch/issues
Depends: R (>= 4.1.0)
Imports: cli, evaluate, htmlwidgets, knitr, reticulate (>= 1.41.0),
        rlang (>= 1.1.0), rstudioapi
Suggests: curl, rmarkdown, testthat (>= 3.0.0), withr
VignetteBuilder: knitr
Config/testthat/edition: 3
Encoding: UTF-8
RoxygenNote: 7.3.3
SystemRequirements: python (>= 3.4.0), SASPy, java (>= 7) required for
        IOM access method
NeedsCompilation: no
Packaged: 2026-02-22 05:51:12 UTC; user
Author: Ryan Zomorrodi [aut, cre, cph] (ORCID:
    <https://orcid.org/0009-0003-6417-5985>)
Maintainer: Ryan Zomorrodi <rzomor2@uic.edu>
Repository: CRAN
Date/Publication: 2026-02-27 19:50:02 UTC
