=== squashfs-tools/LZMA/lzmalt/Makefile ===
INCLUDEDIR = .

CFLAGS := -I$(INCLUDEDIR) -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -O2

all:7zlzma.o  IInOutStreams.o  LZMADecoder.o

clean :
	rm -f *.o
