=== debian/changelog ===
sasquatch (4.5.1-0kali2) kali-dev; urgency=medium

  * Add superficial autopkgtest

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 13 Jun 2023 10:21:48 +0200

sasquatch (4.5.1-0kali1) kali-dev; urgency=medium

  * Update debian/* for Kali

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 12 Jun 2023 16:14:15 +0200
