=== debian/control ===
Source: sasquatch
Section: misc
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Sophie Brun <sophie@offensive-security.com>
Build-Depends: debhelper-compat (= 13), liblzo2-dev, zlib1g-dev, liblz4-dev, liblzma-dev, libzstd-dev
Standards-Version: 4.6.2
Homepage: https://github.com/onekey-sec/sasquatch
Vcs-Browser: https://gitlab.com/kalilinux/packages/sasquatch
Vcs-Git: https://gitlab.com/kalilinux/packages/sasquatch.git
Rules-Requires-Root: no

Package: sasquatch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tool to extract vendor specific SquashFS images
 This package contains a tool to extract vendor specific SquashFS images.
