=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

%:
	dh ${@} --sourcedirectory=squashfs-tools/

override_dh_auto_configure:
	dh_auto_configure -- $(shell dpkg-buildflags --export=cmdline)

override_dh_auto_install:
	dh_auto_install -- INSTALL_DIR=$(CURDIR)/debian/sasquatch/usr/bin
	CFLAGS=-DFIX_BE dh_auto_build
	cp $(CURDIR)/squashfs-tools/sasquatch $(CURDIR)/debian/sasquatch/usr/bin/sasquatch-v4be
