=== debian/tests/control ===
Test-Command: sasquatch -h && sasquatch-v4be -h
Restrictions: superficial
