=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%unblob-$1.tar.gz%" \
   https://github.com/onekey-sec/sasquatch/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
